;*** ZED TEXT EDITOR PROGRAM

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:VI"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

WORK1 = $02 ;(16)
WORK2 = $12 ;(16)
WORK3 = $22 ;(14)

CHR = $0D
CHRAB = $09
CHRUOTE = $22

;SCREEN

SCROPDDR      = $30 ;(2)
SCRINEDDR     = $32 ;(2)
CUROW          = $34 ;(1)
CUROL          = $35 ;(1)
SCROWS         = $36 ;(1)
SCROLS         = $37 ;(1)
SCROWNC       = $38 ;(2)
CUREFTARGIN   = $3A ;(1)
STATUSARGIN    .BUF 1

;DOCUMENT

LINETR         = $40 ;(4)
LINEUM         = $44 ;(4)
TOSINETR      = $48 ;(4)
TOPINETR      = $4C ;(4)
BOTINETR      = $50 ;(4)
LINEOUNT       = $54 ;(4)
FILEENGTH      = $58 ;(4)
TARGETEN       = $5C ;(1)
WRAPLAG        = $5D ;(1) ;128=WRAP,64=SHOW

;MANAGEMENT

MODIFIED        = $3B ;(1) ;$00=NO, $FF=MODIFIED
MODELAGS       = $3C ;(1) ;$80=INSERT, $40=INDENT
STATUSPDATE    = $3D ;(1) ;128=LINE,64=COL,32=MOD,16=INS,8=BYT,4=FRE,2=NM,1=MSG
MARKEDINETR   .BUF 4 ;(4)
MARKEDINEUM   .BUF 4 ;(4)
MARKEDOL       .BUF 4 ;(1)

;LINE FORMAT

HEADUFFER      = $70 ;(11)
HEADEXTTR     = $70 ;(4)
HEADREVTR     = $74 ;(4)
HEADINEEN     = $78 ;(1)
HEADNDENT      = $79 ;(1)
HEADLAGS       = $7A ;(1) ;$80=CONNECTED, $40=NULLINE, $3=INDENT
HEADENGTH      = $0B

;KILL BUFFER

BUFFEROPTR    .BUF 4 ;(4)
BUFFEROTTR    .BUF 4 ;(4)
BUFFERINEOUNT .BUF 4 ;(4)

;DOCUMENT BUFFERS

;COLORS

CHAROLOR   .BYTE $0C  ;$0E
CURSOROLOR .BYTE $06
STATUSOLOR .BYTE $04
SEPAROLOR  .BYTE $0F  ;$03
HILITEOLOR .BYTE $0D  ;$0C
ALERTOLOR  .BYTE $0F
BORDEROLOR .BYTE $00
BKGNDOLOR  .BYTE $00

;=== NEW ===

SCREENNIT = *
   ;** GET SCREEN PARMS
   JSR WINSIZE
   STA SCROWS
   STX SCROLS
   LDA SYSWORK+2
   LDY SYSWORK+3
   STA SCROPDDR+0
   STY SCROPDDR+1
   LDA SYSWORK+4
   LDY SYSWORK+5
   STA SCROWNC+0
   STY SCROWNC+1
   ;** GET COLOR PALETTE
   JSR CONPALETTE
   LDX #7
-  LDA SYSWORK,X
   STA CHAROLOR,X
   DEX
   BPL -
   ;** CLEAR SCREEN
   LDA #$E0
   LDX #$20
   LDY CHAROLOR
   JSR WINCLS
   LDA #2
   LDX #0
   JSR CONPOS
   ;** SET STATUS COLOR
   LDA SCROPDDR+0
   LDY SCROPDDR+1
   STA SYSWORK+0
   STY SYSWORK+1
   LDA SCROLS
   STA SYSWORK+5
   LDA #$60
   LDY STATUSOLOR
   LDX #0
   JSR WINPUT
   ;** SET SEPARATOR COLOR
   JSR SETEPARDDR
   LDA #$60
   LDY SEPAROLOR
   LDX #0
   JSR WINPUT
   JSR DISPLAYEPARATOR
   LDA #$FF
   STA STATUSPDATE
   JSR UPDATETATUS
   RTS

SETEPARDDR = *
   CLC
   LDA SCROPDDR+0
   ADC SCROWNC+0
   STA SYSWORK+0
   LDA SCROPDDR+1
   ADC SCROWNC+1
   STA SYSWORK+1
   RTS

DISPLAYTATUS = *
   LDA SCROPDDR+0
   LDY SCROPDDR+1
   STA SYSWORK+0
   STY SYSWORK+1
   LDA #<STATUSINE
   LDY #>STATUSINE
   CLC
   ADC STATUSARGIN
   BCC +
   INY
+  STA SYSWORK+2
   STY SYSWORK+3
   LDA SCROLS
   STA SYSWORK+5
   LDA #$80
   LDX SCROLS
   JSR WINPUT
   RTS

STATUSINE = *
  .ASC ":12345678:241 *  NS  ND  :12345678  :12345678 "
     ; "0----+----1----+----2----+----3----+----4----+----5-"
  .ASC "1234567890123456789012345678"
     ; "---+----6----+----7----+----"

UPDATETATUS = *
   JSR DISPLAYTATUS
   RTS

DISPLAYEPARATOR = *
   JSR SETEPARDDR
   LDA #"-"
   STA SYSWORK+4
   LDA SCROLS
   STA SYSWORK+5
   LDA #$80
   LDX #0
   JSR WINPUT
   RTS

;=== MAIN ===

MAIN = *
   JSR MALLOCNIT
   JSR MAINNIT
   JSR SCREENNIT
   JSR DISPLAYTATUS
   LDA #1
   LDY #0
   JSR GETARG
   JSR LOADILE
   JSR DUMPOC
   RTS

MSG .ASC "ED FOR  VERSION -0.01"
    .BYTE CHR,0

MAINNIT = *
   LDX #$7F-$02
   LDA #0
-  STA 2,X
   DEX
   BPL -
   LDA #$80
   STA WRAPLAG
   JSR WINSIZE
   STX TARGETEN
   RTS

;*** LOAD FILE: USES WORK2 ***

LOADEAD  = WORK2+0
LOADAIL  = WORK2+4
LOADINES = WORK2+8
LOADYTES = WORK2+12
LOADCB      = WORK3+0
LOADINECAN = WORK3+1
LOADINEEN  = WORK3+2
LOADUFOUNT = WORK3+3
LOADUFTR   = WORK3+4

LOADILE = *  ;( (ZP)=NAME ) : [W2]=HEAD, [W2]=TAIL, [W2]=LINES, [W2]=BYTES
   JSR SAVEORK3
   JSR LOADNIT
   LDA #"R"
   JSR OPEN
   STA LOADCB
-  JSR LOADINE
   BCS +
   JSR LOADINERAP
   JSR LOADINETORE
   JSR LOADINEVERFLOW
   JMP -
+  LDA LOADINEEN
   BEQ +
   JSR LOADINERAP
   LDA #$00
   STA HEADLAGS
   JSR LOADINETORE
+  LDA LOADCB
   JSR CLOSE
   JSR RESTOREORK3
   RTS

LOADNIT = *
   LDA #0
   LDX #16+14-1
-  STA LOADEAD,X
   DEX
   BPL -
   RTS

LOADINE = *  ;( ) : .=END
   ;TAB EXPANSION WILL GO INTO THIS ROUTINE
   LDX LOADUFTR
   LDY LOADINEEN

   LOADEXTYTE = *
   LDA LOADUFOUNT
   BNE ++
   STY LOADINEEN
   JSR LOADUF
   BCC +
   RTS
+  LDY LOADINEEN
   LDX LOADUFTR
+  NOP

-  LDA FILEBUF,X
   STA LINE,Y
   INX
   INY
   CMP #CHR
   BEQ ++
   CPY TARGETEN
   BEQ +  ;DETERMINES IF S WILL GO BEYOND LEN
   BCS ++
+  DEC LOADUFOUNT
   BNE -
   BEQ LOADEXTYTE

+  DEC LOADUFOUNT
   STX LOADUFTR
   STY LOADINEEN
   CLC
   RTS

LOADUF = *  ;( ) : .=EOF
   JSR STOPKEY
   BCS +
   LDA #<FILEBUF
   LDY #>FILEBUF
   STA ZP+0
   STY ZP+1
   LDA #<254
   LDY #>254
   LDX LOADCB
   JSR READ
   BCS +
   BEQ +
   STA LOADUFOUNT
   LDA #0
   STA LOADUFTR
   CLC
   RTS
+  SEC
   RTS

LOADINERAP = *
   LDX LOADINEEN
   DEX
   LDY #$00
   LDA LINE,X
   CMP #CHR
   BEQ +
   LDY #$80
+  STY HEADLAGS
   CMP #CHR
   BNE +
-  STX HEADINEEN
   STX LOADINECAN
   STX LOADINEEN
   RTS

+  LDX LOADINEEN
   CPX TARGETEN
   BCC -

+  BIT WRAPLAG
   BMI +
-  LDA TARGETEN
   STA LOADINECAN
   STA HEADINEEN
   RTS

+  LDX TARGETEN
-  DEX
   CPX #255
   BEQ --
   LDA LINE,X
   CMP #" "
   BNE -
+  INX
   STX LOADINECAN
   STX HEADINEEN
   RTS

LOADINETORE = *
   INC LOADINES+0
   BNE +
   INC LOADINES+1
   BNE +
   INC LOADINES+2
   BNE +
   INC LOADINES+3
+  SEC
   BIT HEADLAGS
   BMI +
   CLC
+  LDA LOADYTES+0
   ADC HEADINEEN
   STA LOADYTES+0
   BCC +
   INC LOADYTES+1
   BNE +
   INC LOADYTES+2
   BNE +
   INC LOADYTES+3
+  LDX #3
-  LDA #ACEEMULL
   STA HEADEXTTR,X
   LDA LOADAIL,X
   STA HEADREVTR,X
   DEX
   BPL -
   JSR STASHINE

   ;** FIRST LINE TO BE STORED
   LDA LOADEAD+3
   CMP #ACEEMULL
   BNE +
   LDX #3
-  LDA MP,X
   STA LOADEAD,X
   STA LOADAIL,X
   DEX
   BPL -
   RTS

   ;** ADDITIONAL LINES
+  LDX #3
-  LDA MP,X
   LDY LOADAIL,X
   STA LOADAIL,X
   STY MP,X
   DEX
   BPL -
   JSR FETCHEAD
   LDX #3
-  LDA LOADAIL,X
   STA HEADEXTTR,X
   DEX
   BPL -
   JSR STASHEAD
   RTS

LOADINEVERFLOW = *
   LDX LOADINECAN
   LDY #0
-  CPX LOADINEEN
   BCS +
   LDA LINE,X
   STA LINE,Y
   INX
   INY
   BNE -
+  STY LOADINEEN
   RTS

;=== MANAGEMENT ROUTINES ===

WORK3AVE .BUF 14

SAVEORK3 = *
   LDX #13
-  LDA WORK3,X
   STA WORK3AVE,X
   DEX
   BPL -
   RTS

RESTOREORK3 = *
   LDX #13
-  LDA WORK3AVE,X
   STA WORK3,X
   DEX
   BPL -
   RTS

FETCHINEXTRA = 6

FETCHINE = *  ;( [MP]=FARINE ) : HEAD*, LINEBUF
   LDA #<LINEBUF
   LDY #>LINEBUF
   STA ZP+0
   STY ZP+1
   LDA #HEADENGTH+FETCHINEXTRA
   LDY #0
   JSR FETCH
   LDX #HEADENGTH-1
-  LDA LINEBUF,X
   STA HEADUFFER,X
   DEX
   BPL -
   LDA HEADINEEN
   CMP #FETCHINEXTRA+1
   BCC +
   CLC
   ADC #HEADENGTH
   LDY #0
   JSR FETCH
+  RTS

STASHINE = *  ;( HEAD*, LINEBUF ) : [MP]=STOREDINE, .=ERR
   LDA #0
   STA HEADNDENT
   LDX #HEADENGTH-1
-  LDA HEADUFFER,X
   STA LINEBUF,X
   DEX
   BPL -
   CLC
   LDA HEADINEEN
   ADC #HEADENGTH
   LDY #0
   JSR MALLOC
   BCC +
   RTS
+  LDA #<LINEBUF
   LDY #>LINEBUF
   STA ZP+0
   STY ZP+1
   CLC
   LDA HEADINEEN
   ADC #HEADENGTH
   LDY #0
   JSR STASH
   CLC
   RTS
   
FETCHEAD = *  ;( [MP]=FARINETR ) : HEADUFFER
   LDX #HEADUFFER
   LDY #HEADENGTH
   JSR ZPLOAD
   RTS

STASHEAD = *  ;( [MP]=FARINETR, HEADUFFER )
   LDX #HEADUFFER
   LDY #HEADENGTH
   JSR ZPSTORE
   RTS

;=== DYNAMIC MEMORY ROUTINES ===

MALLOCORK = WORK1

MALLOCEAD   .BUF 4
TPAREEIRST .BUF 1
TPAREEIN   .BUF 1
TPAREEAGES .BUF 1
TPAREATART .BUF 1
TPAREAND   .BUF 1

;*** MALLOCNIT()

MALLOCNIT = *
   LDA #ACEEMULL
   STA MALLOCEAD+3
   LDX #0
   LDA #$FF
-  STA TPAREEMAP,X
   INX
   BNE -
   LDX #>BSSND
   LDA #<BSSND
   BEQ +
   INX
+  STX TPAREEIRST
   STX TPAREATART
   LDX ACEEMOP+1
   STX MALLOCORK
   STX TPAREAND
   TXA
   SEC
   SBC TPAREEIRST
   BCS +
   LDA #0
+  STA TPAREEAGES
   CLC
   ADC #1
   STA TPAREEIN
   LDX TPAREEIRST
   CPX MALLOCORK
   BCS +
   LDA #$00
-  STA TPAREEMAP,X
   INX
   CPX MALLOCORK
   BCC -
+  RTS

LIBAGES .BUF 1

LIBAGELLOC = *  ;( .=PAGES ) : [MP]
   STA LIBAGES
   LDX #$00
   LDY #ACEEMNTERNAL-1
   JSR PAGEALLOC
   BCS +
   RTS
+  JSR TPAAGELLOC
   BCS +
   RTS
+  LDA LIBAGES
   LDX #ACEEMNTERNAL
   LDY #$FF
   JSR PAGEALLOC
   BCS +
   RTS
+  LDA #<NOMEMSG
   LDY #>NOMEMSG
   JSR EPUTS
   LDA #1
   JMP EXIT

   NOMEMSG = *
   .BYTE CHR
   .ASC "NSUFFICIENT MEMORY, ABORTING."
   .BYTE CHR,0

NEWMAX   .BUF 1

TPAAGELLOC = *  ;( LIBAGES ) : [MP]
   LDA LIBAGES
   CMP TPAREEIN
   BCS TPAREEMAPULL
   ;** FIRST FREE
   LDX TPAREEIRST
   LDA TPAREEMAP,X
   BEQ ++
-  INX
   BEQ TPAREEMAPULL
   LDA TPAREEMAP,X
   BNE -
   STX TPAREEIRST
   JMP ++
   TPAREEMAPULL = *
   LDA LIBAGES
   CMP TPAREEIN
   BCS +
   STA TPAREEIN
+  SEC
   RTS

   ;** SEARCH
+  DEX
-  LDY LIBAGES
-  INX
   BEQ TPAREEMAPULL
   LDA TPAREEMAP,X
   BNE --
   DEY
   BNE -

   ;** ALLOCATE
   STX NEWMAX
   LDY LIBAGES
   LDA #$41
-  STA TPAREEMAP,X
   DEX
   DEY
   BNE -
   INX
   CPX TPAREEIRST
   BNE +
   LDY NEWMAX
   INY
   STY TPAREEIRST
+  SEC
   LDA TPAREEAGES
   SBC LIBAGES
   STA TPAREEAGES
   LDA #0
   LDY #ACEEMNTERNAL
   STA MP+0
   STX MP+1
   STA MP+2
   STY MP+3
   CLC
   RTS

MALLOCENAVE .BUF 3

MALLOC = *
QUICKALLOC = *
   STA MALLOCENAVE+0
   STY MALLOCENAVE+1
   JSR LIBALLOC
   BCS +
   RTS
+  LDX MALLOCENAVE+1
   LDA MALLOCENAVE+0
   BEQ +
   INX
+  TXA
   CPX #>1024
   BCS +
   LDX #>1024
+  TXA
   STA MALLOCENAVE+2
   JSR LIBAGELLOC
   BCC +
   RTS
+  LDA #0
   LDY MALLOCENAVE+2
   JSR FREE
   LDA MALLOCENAVE+0
   LDY MALLOCENAVE+1
   JMP MALLOC

;*** MALLOC( .=YTES ) : [MP]=AROINTER

MALLOCEMEXTTR = MALLOCORK+0 ;(4)
MALLOCEMENGTH  = MALLOCORK+4 ;(2)
MALLOCENGTH     = MALLOCORK+6 ;(2)
MALLOC          = MALLOCORK+8 ;(4)

LIBALLOC = *
   CLC
   ADC #7
   BCC +
   INY
+  AND #$F8
   STA MALLOCENGTH
   STY MALLOCENGTH+1
   LDX #3
-  LDA MALLOCEAD,X
   STA MP,X
   LDA #ACEEMULL
   STA MALLOC,X
   DEX
   BPL -

   MALLOCOOK = *
   LDA MP+3
   CMP #ACEEMULL
   BNE +

   MALLOCRRORXIT = *
   LDA #ACEEMULL
   STA MP+3
   LDA #ACERRNSUFFICIENTEMORY
   STA ERRNO
   SEC
   RTS

+  LDX #MALLOCEMEXTTR
   LDY #6
   JSR ZPLOAD
   LDA MALLOCEMENGTH
   CMP MALLOCENGTH
   LDA MALLOCEMENGTH+1
   SBC MALLOCENGTH+1
   BCS MALLOCOTLOCK
   LDX #3
-  LDA MP,X
   STA MALLOC,X
   LDA MALLOCEMEXTTR,X
   STA MP,X
   DEX
   BPL -
   JMP MALLOCOOK

   MALLOCOTLOCK = *
   LDA MALLOCEMENGTH
   CMP MALLOCENGTH
   BNE +
   LDA MALLOCEMENGTH+1
   SBC MALLOCENGTH+1
   BEQ MALLOCAKEHOLELOCK
+  SEC
   LDA MALLOCEMENGTH
   SBC MALLOCENGTH
   STA MALLOCEMENGTH
   LDA MALLOCEMENGTH+1
   SBC MALLOCENGTH+1
   STA MALLOCEMENGTH+1
   LDX #MALLOCEMEXTTR
   LDY #6
   JSR ZPSTORE
   CLC
   LDA MP+0
   ADC MALLOCEMENGTH
   STA MP+0
   LDA MP+1
   ADC MALLOCEMENGTH+1
   STA MP+1
   CLC
   RTS

   MALLOCAKEHOLELOCK = *
   LDA MALLOC+3
   CMP #ACEEMULL
   BNE +
   LDX #3
-  LDA MALLOCEMEXTTR,X
   STA MALLOCEAD,X
   DEX
   BPL -
   CLC
   RTS
+  LDX #3
-  LDA MP,X
   LDY MALLOC,X
   STA MALLOC,X
   STY MP,X
   DEX
   BPL -
   LDX #MALLOCEMEXTTR
   LDY #4
   JSR ZPSTORE
   LDX #3
-  LDA MALLOC,X
   STA MP,X
   DEX
   BPL -
   CLC
   RTS

;*** FREE( [MP]=AROINTER, .=ENGTH )  ALTERS [MP]

FREEEMEXTTR = MALLOCORK+0  ;(4)
FREEEMENGTH  = MALLOCORK+4  ;(2)
FREEENGTH     = MALLOCORK+6  ;(2)
FREEEWTR     = MALLOCORK+8  ;(4)
FREE          = MALLOCORK+12 ;(4)

FREE = *
   CLC
   ADC #7
   BCC +
   INY
+  AND #$F8
   STA FREEENGTH+0
   STY FREEENGTH+1
   LDX #3
-  LDA MP,X
   STA FREEEWTR,X
   LDA MALLOCEAD,X
   STA MP,X
   LDA #ACEEMULL
   STA FREE,X
   DEX
   BPL -

   FREEEARCHOOP = *
   LDA MP+3
   CMP #ACEEMULL
   BEQ FREEOALESCEANDEW
   LDA MP+0
   CMP FREEEWTR+0
   LDA MP+1
   SBC FREEEWTR+1
   LDA MP+2
   SBC FREEEWTR+2
   LDA MP+3
   SBC FREEEWTR+3
   BCS FREEOALESCEANDEW
+  LDX #FREEEMEXTTR
   LDY #4
   JSR ZPLOAD
   LDX #3
-  LDA MP,X
   STA FREE,X
   LDA FREEEMEXTTR,X
   STA MP,X
   DEX
   BPL -
   BMI FREEEARCHOOP

   FREEOALESCEANDEW = *
   LDX #3
-  LDA FREE,X
   STA MP,X
   DEX
   BPL -
   LDA MP+3
   CMP #ACEEMULL
   BNE +
   ;** PREV IS HEAD
   LDX #3
-  LDA MALLOCEAD,X
   STA FREEEMEXTTR,X
   LDA FREEEWTR,X
   STA MALLOCEAD,X
   DEX
   BPL -
   LDA FREEENGTH+0
   LDY FREEENGTH+1
   STA FREEEMENGTH+0
   STY FREEEMENGTH+1
   JMP FREEOALESCEEWND

   ;** PREV IS REAL
+  LDX #FREEEMEXTTR
   LDY #6
   JSR ZPLOAD
   LDA MP+3
   CMP FREEEWTR+3
   BNE +
   LDA MP+2
   CMP FREEEWTR+2
   BNE +
   CLC
   LDA MP+0
   ADC FREEEMENGTH
   TAX
   LDA MP+1
   ADC FREEEMENGTH+1
   CMP FREEEWTR+1
   BNE +
   CPX FREEEWTR
   BNE +
   ;** PREV DOES COALESCE
   CLC
   LDA FREEEMENGTH
   ADC FREEENGTH
   STA FREEEMENGTH
   LDA FREEEMENGTH+1
   ADC FREEENGTH+1
   STA FREEEMENGTH+1
   LDX #3
-  LDA FREE,X
   STA FREEEWTR,X
   DEX
   BPL -
   BMI FREEOALESCEEWND

   ;** PREV DOES NOT COALESCE
+  LDX #FREEEWTR
   LDY #4
   JSR ZPSTORE
   LDA FREEENGTH+0
   LDY FREEENGTH+1
   STA FREEEMENGTH+0
   STY FREEEMENGTH+1

   FREEOALESCEEWND = *
   LDA FREEEWTR+3
   CMP FREEEMEXTTR+3
   BNE +
   LDA FREEEWTR+2
   CMP FREEEMEXTTR+2
   BNE +
   CLC
   LDA FREEEWTR
   ADC FREEEMENGTH
   TAX
   LDA FREEEWTR+1
   ADC FREEEMENGTH+1
   CMP FREEEMEXTTR+1
   BNE +
   CPX FREEEMEXTTR
   BNE +

   ;** NEW AND NEXT COALESCE
   LDX #3
-  LDA FREEEMEXTTR,X
   STA MP,X
   DEX
   BPL -
   LDA FREEEMENGTH+1
   PHA
   LDA FREEEMENGTH+0
   PHA
   LDX #FREEEMEXTTR
   LDY #6
   JSR ZPLOAD
   CLC
   PLA
   ADC FREEEMENGTH+0
   STA FREEEMENGTH+0
   PLA
   ADC FREEEMENGTH+1
   STA FREEEMENGTH+1

+  LDX #3
-  LDA FREEEWTR,X
   STA MP,X
   DEX
   BPL -
   LDX #FREEEMEXTTR
   LDY #6
   JSR ZPSTORE
   CLC
   RTS

;=== STANDARD LIBRARY ===

PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   STX XSAVE
   STY YSAVE
   LDX #STDOUT
   JSR PUTC
   LDX XSAVE
   LDY YSAVE
   RTS
   XSAVE .BUF 1
   YSAVE .BUF 1

PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP+0
   STA ZP+1
   RTS

;=== ===

STOPOUNTDOWN .BYTE 0

DUMPOC = *
   LDA #$E0
   LDX #$20
   LDY CHAROLOR
   JSR WINCLS

   LDX #3
-  LDA LOADEAD,X
   STA MP,X
   DEX
   BPL -

-  LDA MP+3
   CMP #ACEEMULL
   BNE +
   RTS
+  JSR FETCHINE
   LDA #<LINE
   LDY #>LINE
   STA ZP+0
   STY ZP+1
   LDA HEADINEEN
   LDY #0
   LDX #STDOUT
   JSR WRITE
   LDA HEADLAGS
   BPL +
   ;LDA #"="
   ;JSR PUTCHAR
+  LDA #CHR
   JSR PUTCHAR
   LDX #3
-  LDA HEADEXTTR,X
   STA MP,X
   DEX
   BPL -
   INC STOPOUNTDOWN
   LDA STOPOUNTDOWN
   AND #7
   BNE +
   JSR STOPKEY
   BCC +
   LDA #1
   LDX #0
   JMP EXIT
+  JMP --

;===BSS===

BSS             = *
LINEBUF         = BSS+0  ;(256)
LINE            = LINEBUF+HEADENGTH ;(241)

FILEBUF         = LINEBUF+256  ;(256)
TPAREEMAP      = FILEBUF+256  ;(256)
BSSND          = TPAREEMAP+256
